using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Maestros._3_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Linq;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_Maestros.General;
using System.Globalization;

namespace Exferia_Maestros._3_Vistas
{
    public partial class P_TarifaPromocion : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private P_TarifaPromocion_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();
        #endregion

        #region Objetos en Pantalla
        //Exferia_CheckBox
        internal Exferia_CheckBox Exferia_CheckBox_Desactivada { get { return ex_chk_P_TarifaPromocion_Desactivada; } }

        //Exferia_ComboBox
        internal Exferia_ComboBox Exferia_ComboBox_PreciosPromociones_Embalaje { get { return ex_cbo_P_TarifaPromocion_PreciosPromociones_Embalaje; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_PreciosPromociones_Articulo { get { return ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Articulo; } }
        internal Exferia_F3 Exferia_F3_PreciosPromociones_Nomenclatura { get { return ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Codigo { get { return ex_lbl_P_TarifaPromocion_Codigo; } }
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_P_TarifaPromocion_Descripcion; } }
        internal Exferia_Label Exferia_Label_PreciosPromociones_Precio { get { return ex_lbl_P_TarifaPromocion_PreciosPromociones_Precio; } }
        internal Exferia_Label Exferia_Label_PreciosPromociones_DescuentoMoneda { get { return ex_lbl_P_TarifaPromocion_PreciosPromociones_DescuentoMoneda; } }
        internal Exferia_Label Exferia_Label_PreciosPromociones_Cantidad { get { return ex_lbl_P_TarifaPromocion_PreciosPromociones_Cantidad; } }
        internal Exferia_Label Exferia_Label_PreciosPromociones_Porcentaje_CantidadB { get { return ex_lbl_P_TarifaPromocion_PreciosPromociones_Porcentaje_CantidadB; } }
        internal Exferia_Label Exferia_Label_PreciosPromociones_Embalaje { get { return ex_lbl_P_TarifaPromocion_PreciosPromociones_Embalaje; } }

        //Exferia_Panel_Degradado
        internal Exferia_Panel_Degradado Exferia_Panel_Degradado_AportacionProveedor { get { return ex_pnl_P_TarifaPromocion_AportacionProveedor; } }
        internal Exferia_Panel_Degradado Exferia_Panel_Degradado_PromocionUnidades { get { return ex_pnl_P_TarifaPromocion_PreciosPromociones_PromocionUnidades; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_TarifaPromocion { get { return ex_Paginador; } }

        //Exferia_RadioButton
        internal Exferia_RadioButton Exferia_RadioButton_Tipo_Cliente { get { return ex_rdb_P_TarifaPromocion_Tipo_Cliente; } }
        internal Exferia_RadioButton Exferia_RadioButton_Tipo_Proveedor { get { return ex_rdb_P_TarifaPromocion_Tipo_Proveedor; } }
        internal Exferia_RadioButton Exferia_RadioButton_AportacionProveedor_Coste { get { return ex_rdb_P_TarifaPromocion_AportacionProveedor_Coste; } }
        internal Exferia_RadioButton Exferia_RadioButton_AportacionProveedor_Venta { get { return ex_rdb_P_TarifaPromocion_AportacionProveedor_Venta; } }
        internal Exferia_RadioButton Exferia_RadioButton_AportacionProveedor_Tarifa { get { return ex_rdb_P_TarifaPromocion_AportacionProveedor_Tarifa; } }
        internal Exferia_RadioButton Exferia_RadioButton_Tipo_Promocion { get { return ex_rdb_P_TarifaPromocion_Tipo_Promocion; } }
        internal Exferia_RadioButton Exferia_RadioButton_Tipo_Tarifa { get { return ex_rdb_P_TarifaPromocion_Tipo_Tarifa; } }
        internal Exferia_RadioButton Exferia_RadioButton_Decimales_0 { get { return ex_rdb_P_TarifaPromocion_Decimales_0; } }
        internal Exferia_RadioButton Exferia_RadioButton_Decimales_1 { get { return ex_rdb_P_TarifaPromocion_Decimales_1; } }
        internal Exferia_RadioButton Exferia_RadioButton_Decimales_2 { get { return ex_rdb_P_TarifaPromocion_Decimales_2; } }
        internal Exferia_RadioButton Exferia_RadioButton_Decimales_3 { get { return ex_rdb_P_TarifaPromocion_Decimales_3; } }
        internal Exferia_RadioButton Exferia_RadioButton_PreciosPromociones_PrecioFijo { get { return ex_rdb_P_TarifaPromocion_PreciosPromociones_PrecioFijo; } }
        internal Exferia_RadioButton Exferia_RadioButton_PreciosPromociones_PrecioDinamico { get { return ex_rdb_P_TarifaPromocion_PreciosPromociones_PrecioDinamico; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Codigo { get { return ex_txt_P_TarifaPromocion_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_P_TarifaPromocion_Descripcion; } }
        internal Exferia_TextBox Exferia_TextBox_Incremento { get { return ex_txt_P_TarifaPromocion_Incremento; } }
        internal Exferia_TextBox Exferia_TextBox_Descuento_1 { get { return ex_txt_P_TarifaPromocion_Descuento_1; } }
        internal Exferia_TextBox Exferia_TextBox_Descuento_2 { get { return ex_txt_P_TarifaPromocion_Descuento_2; } }
        internal Exferia_TextBox Exferia_TextBox_Descuento_3 { get { return ex_txt_P_TarifaPromocion_Descuento_3; } }
        internal Exferia_TextBox Exferia_TextBox_Descuento_4 { get { return ex_txt_P_TarifaPromocion_Descuento_4; } }
        internal Exferia_TextBox Exferia_TextBox_Descuento_5 { get { return ex_txt_P_TarifaPromocion_Descuento_5; } }
        internal Exferia_TextBox Exferia_TextBox_AportacionProveedor_Porcentaje { get { return ex_txt_P_TarifaPromocion_AportacionProveedor_Porcentaje; } }
        internal Exferia_TextBox Exferia_TextBox_PreciosPromociones_Precio { get { return ex_txt_P_TarifaPromocion_PreciosPromociones_Precio; } }
        internal Exferia_TextBox Exferia_TextBox_PreciosPromociones_DescuentoMoneda { get { return ex_txt_P_TarifaPromocion_PreciosPromociones_DescuentoMoneda; } }
        internal Exferia_TextBox Exferia_TextBox_PreciosPromociones_Cantidad_A { get { return ex_txt_P_TarifaPromocion_PreciosPromociones_Cantidad_A; } }
        internal Exferia_TextBox Exferia_TextBox_PreciosPromociones_Cantidad_B { get { return ex_txt_P_TarifaPromocion_PreciosPromociones_Cantidad_B; } }
        internal Exferia_TextBox Exferia_TextBox_PreciosPromociones_Porcentaje_CantidadB { get { return ex_txt_P_TarifaPromocion_PreciosPromociones_Porcentaje_CantidadB; } }

        #endregion

        #region Constructor
        public P_TarifaPromocion(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                 DateTime _dtt_FechaTrabajo,
                                 PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            CargarDatos_Constructor(_mdl_INTERNO_ValoresGenerales_Modelo,
                                  _dtt_FechaTrabajo,
                                  _mdl_PRV_OpcionesDetalle,
                                 -1,
                                 -1);
        }
        public P_TarifaPromocion(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, 
                                 DateTime _dtt_FechaTrabajo, 
                                 PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle,
                                 int _int_ClienteProveedor,
                                 int _int_TarifaPromocion)
        {
            InitializeComponent();

            CargarDatos_Constructor(_mdl_INTERNO_ValoresGenerales_Modelo,
                                    _dtt_FechaTrabajo,
                                    _mdl_PRV_OpcionesDetalle,
                                    _int_ClienteProveedor,
                                    _int_TarifaPromocion);
        }

        private void CargarDatos_Constructor(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                             DateTime _dtt_FechaTrabajo,
                                             PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle,
                                             int _int_ClienteProveedor,
                                             int _int_TarifaPromocion)
        {
            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_TarifaPromocion_Controladora(this, _int_ClienteProveedor, _int_TarifaPromocion);

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_TarifaPromocion_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_TarifaPromocion_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .......................................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                //Tipo de campo Codigo, poner como numérico o texto ...............................
                if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO != null)
                {
                    //Si no existe es Text
                    if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO.Where(m => m.nombreCampoCodigo.Equals(nameof(MAE_TarifasPromociones.codigo)) && m.opcion.Equals(g_mdl_PRV_OpcionesDetalle.opcion)).FirstOrDefault() != null)
                    {
                        ex_txt_P_TarifaPromocion_Codigo.Exferia_TextBox_Tipos = G_ENUM_TEXTBOX_TIPODATO.Digitos;
                        ex_txt_P_TarifaPromocion_Codigo.Exferia_TextBox_Tipo_Decimal_Enteros = ex_txt_P_TarifaPromocion_Codigo.Exferia_TextBox_MaxLength;

                        g_obj_Controladora.g_bol_CampoCodigo_Numerico = true;
                    }
                }
                //................................................................................


                // Label con Empresa Seleccionada
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra el mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_TarifaPromocion) + "/" + nameof(P_TarifaPromocion));
                    }
                }
                //........................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Rellenar para los F3 ............................................
                //NOMENCLATURAS
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_NOMENCLATURAPRECIO;
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Exferia_F3_PantallaContenedora = this;

                //ARTICULOS
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Articulo.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_ARTICULO;
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Articulo.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Articulo.Exferia_F3_PRINCIPAL_Obligatorio = false;

            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_TarifaPromocion) + "/" + nameof(CargarDatos_Constructor));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de Pantalla
        private void P_TarifaPromocion_Load(object sender, EventArgs e)
        {
            try
            {
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_TarifaPromocion) + "/" + nameof(P_TarifaPromocion_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_TarifaPromocion_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                Exferia_TextBox_Codigo.Text = P_Base_Campo_1;
                                Exferia_TextBox_Descripcion.Exferia_TextBox_Foco();
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                Exferia_TextBox_Descripcion.Text = P_Base_Campo_2;
                                Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
                        }

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                    }
                    //Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_TarifaPromocion.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_TarifaPromocion.Visible = false;
                        }
                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_TarifaPromocion) + "/" + nameof(P_TarifaPromocion_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }

        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_TarifaPromocion.Visible)
            {
                Exferia_Paginador_TarifaPromocion.Visible = _bol_Activar;
            }

            if (ex_btn_P_TarifaPromocion_Borrar.Enabled)
            {
                ex_btn_P_TarifaPromocion_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar, Borrar, BuscarCodigoSiguiente
        private void ex_btn_P_TarifaPromocion_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                 (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                 //Modificar
                 (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_TarifaPromocion_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }

        private void btn_P_TarifaPromocion_BuscarCodigoSiguiente_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Tipo Cliente/Proveedor
        private void ex_rdb_P_TarifaPromocion_Tipo_Cliente_CheckedChanged(object sender, EventArgs e)
        {
            if (g_obj_Controladora!=null && g_obj_Controladora.g_bol_CargarDatos_Termino)
            {
                if (ex_rdb_P_TarifaPromocion_Tipo_Cliente.Checked)
                {
                    if (ex_rdb_P_TarifaPromocion_Tipo_Promocion.Checked)
                    {
                        ex_pnl_P_TarifaPromocion_AportacionProveedor.Visible = true;
                    }
                }

                Controlar_Modificaciones();
            }
        }

        private void ex_rdb_P_TarifaPromocion_Tipo_Proveedor_CheckedChanged(object sender, EventArgs e)
        {
            if (g_obj_Controladora != null && g_obj_Controladora.g_bol_CargarDatos_Termino)
            {
                if (ex_rdb_P_TarifaPromocion_Tipo_Proveedor.Checked)
                {
                    ex_pnl_P_TarifaPromocion_AportacionProveedor.Visible = false;
                }

                Controlar_Modificaciones();
            }
        }
        #endregion

        #region Tarifa/Promocion
        private void ex_rdb_P_TarifaPromocion_Tipo_Tarifa_CheckedChanged(object sender, EventArgs e)
        {
            if (g_obj_Controladora != null && g_obj_Controladora.g_bol_CargarDatos_Termino)
            {
                if (ex_rdb_P_TarifaPromocion_Tipo_Tarifa.Checked)
                {
                    ex_pnl_P_TarifaPromocion_AportacionProveedor.Visible = false;

                    //Ocultar promocion y poner como obligatorio el precio
                    g_obj_Controladora.Cambiar_PromocionesPorUnidades_Precio(false,true);
                }

                Controlar_Modificaciones();
            }
        }

        private void ex_rdb_P_TarifaPromocion_Tipo_Promocion_CheckedChanged(object sender, EventArgs e)
        {
            if (g_obj_Controladora != null && g_obj_Controladora.g_bol_CargarDatos_Termino)
            {
                if (ex_rdb_P_TarifaPromocion_Tipo_Promocion.Checked)
                {
                    if (ex_rdb_P_TarifaPromocion_Tipo_Cliente.Checked)
                    {
                        ex_pnl_P_TarifaPromocion_AportacionProveedor.Visible = true;
                    }

                    //Mostrar promocion y poner como no obligatorio el precio
                    g_obj_Controladora.Cambiar_PromocionesPorUnidades_Precio(true, false);
                }

                Controlar_Modificaciones();
            }
        }
        #endregion

        private void ex_rdb_P_TarifaPromocion_PreciosPromociones_PrecioFijo_CheckedChanged(object sender, EventArgs e)
        {
            if (ex_rdb_P_TarifaPromocion_PreciosPromociones_PrecioFijo.Checked)
            {
                ex_txt_P_TarifaPromocion_PreciosPromociones_Precio.Enabled = true;
            }
            else
            {
                ex_txt_P_TarifaPromocion_PreciosPromociones_Precio.Enabled = false;

                //Vaciar
                ex_txt_P_TarifaPromocion_PreciosPromociones_Precio.Text = "";
            }

            Controlar_Modificaciones();
        }

        private void ex_rdb_P_TarifaPromocion_PreciosPromociones_PrecioDinamico_CheckedChanged(object sender, EventArgs e)
        {
            if (ex_rdb_P_TarifaPromocion_PreciosPromociones_PrecioDinamico.Checked)
            {
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Enabled = true;
            }
            else
            {
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Enabled = false;

                //Vaciar
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Exferia_F3_Id = -1;
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Exferia_F3_Codigo = "";
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Exferia_F3_Descripcion = "";
                ex_usc_F3_P_TarifaPromocion_PreciosPromociones_Nomenclatura.Exferia_F3_FechaBorrado = null;
            }

            Controlar_Modificaciones();
        }

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TarifaPromocion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TarifaPromocion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TarifaPromocion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TarifaPromocion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_TarifaPromocion.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TarifaPromocion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso Rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifica algo

        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }
        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }
        private void Controlar_Modificaciones_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }
        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();

        }
        public void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }


        #endregion

        
    }
}
